<html>
<head>
<title>OgreProfiler.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreProfiler.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreProfiler_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="comment">/*</span>
<a name="l00029"></a>00029 <span class="comment"></span>
<a name="l00030"></a>00030 <span class="comment">    Although the code is original, many of the ideas for the profiler were borrowed from </span>
<a name="l00031"></a>00031 <span class="comment">&quot;Real-Time In-Game Profiling&quot; by Steve Rabin which can be found in Game Programming</span>
<a name="l00032"></a>00032 <span class="comment">Gems 1.</span>
<a name="l00033"></a>00033 <span class="comment"></span>
<a name="l00034"></a>00034 <span class="comment">    This code can easily be adapted to your own non-Ogre project. The only code that is </span>
<a name="l00035"></a>00035 <span class="comment">Ogre-dependent is in the visualization/logging routines and the use of the Timer class.</span>
<a name="l00036"></a>00036 <span class="comment"></span>
<a name="l00037"></a>00037 <span class="comment">    Enjoy!</span>
<a name="l00038"></a>00038 <span class="comment"></span>
<a name="l00039"></a>00039 <span class="comment">*/</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="preprocessor">#ifndef __Profiler_H__</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span><span class="preprocessor">#define __Profiler_H__</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span>
<a name="l00044"></a>00044 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00045"></a>00045 <span class="preprocessor">#include &quot;<a class="code" href="OgreSingleton_8h.html">OgreSingleton.h</a>&quot;</span>
<a name="l00046"></a>00046 <span class="preprocessor">#include &quot;<a class="code" href="OgreString_8h.html">OgreString.h</a>&quot;</span>
<a name="l00047"></a>00047 <span class="preprocessor">#include &quot;<a class="code" href="OgreOverlay_8h.html">OgreOverlay.h</a>&quot;</span>
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="preprocessor">#if OGRE_PROFILING == 1</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span><span class="preprocessor">#   define OgreProfile( a ) Ogre::Profile _OgreProfileInstance( (a) )</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span><span class="preprocessor">#   define OgreProfileBegin( a ) Ogre::Profiler::getSingleton().beginProfile( (a) )</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span><span class="preprocessor">#   define OgreProfileEnd( a ) Ogre::Profiler::getSingleton().endProfile( (a) )</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span><span class="preprocessor">#   define OgreProfileGroup( a, g ) Ogre::Profile _OgreProfileInstance( (a), (g) )</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span><span class="preprocessor">#   define OgreProfileBeginGroup( a, g ) Ogre::Profiler::getSingleton().beginProfile( (a), (g) )</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span><span class="preprocessor">#   define OgreProfileEndGroup( a, g ) Ogre::Profiler::getSingleton().endProfile( (a), (g) )</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00057"></a><a class="code" href="OgreProfiler_8h.html#a1654899e6cfdec9f0972a45f3fa3fee7">00057</a> <span class="preprocessor"></span><span class="preprocessor">#   define OgreProfile( a )</span>
<a name="l00058"></a><a class="code" href="OgreProfiler_8h.html#af9d7ab83c5a5d7de7579eebe9d27e53d">00058</a> <span class="preprocessor"></span><span class="preprocessor">#   define OgreProfileBegin( a )</span>
<a name="l00059"></a><a class="code" href="OgreProfiler_8h.html#a292ec22b5d851ef26fa9d7685c18b1f5">00059</a> <span class="preprocessor"></span><span class="preprocessor">#   define OgreProfileEnd( a )</span>
<a name="l00060"></a><a class="code" href="OgreProfiler_8h.html#af0b42a7cef7035e033b55dbd3196d07d">00060</a> <span class="preprocessor"></span><span class="preprocessor">#   define OgreProfileGroup( a, g ) </span>
<a name="l00061"></a><a class="code" href="OgreProfiler_8h.html#a76abda9b4a68907da2df018cd5253651">00061</a> <span class="preprocessor"></span><span class="preprocessor">#   define OgreProfileBeginGroup( a, g ) </span>
<a name="l00062"></a><a class="code" href="OgreProfiler_8h.html#adc97ff9c6f56d0452bc0b1910bbab76a">00062</a> <span class="preprocessor"></span><span class="preprocessor">#   define OgreProfileEndGroup( a, g ) </span>
<a name="l00063"></a>00063 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span>
<a name="l00065"></a>00065 <span class="keyword">namespace </span>Ogre {
<a name="l00075"></a><a class="code" href="group__General.html#ga22a20f11c008a0d9b677fc2635922cfe">00075</a>     <span class="keyword">enum</span> <a class="code" href="group__General.html#ga22a20f11c008a0d9b677fc2635922cfe" title="List of reserved profiling masks.">ProfileGroupMask</a>
<a name="l00076"></a>00076     {
<a name="l00078"></a><a class="code" href="group__General.html#gga22a20f11c008a0d9b677fc2635922cfea721f30014dd7fbcd0bfb075ab74ab7d3">00078</a>         <a class="code" href="group__General.html#gga22a20f11c008a0d9b677fc2635922cfea721f30014dd7fbcd0bfb075ab74ab7d3" title="User default profile.">OGREPROF_USER_DEFAULT</a> = 0x00000001,
<a name="l00080"></a><a class="code" href="group__General.html#gga22a20f11c008a0d9b677fc2635922cfeade870d108856d0d9fbd27694bcb2242a">00080</a>         <a class="code" href="group__General.html#gga22a20f11c008a0d9b677fc2635922cfeade870d108856d0d9fbd27694bcb2242a" title="All in-built Ogre profiling will match this mask.">OGREPROF_ALL</a> = 0xFF000000,
<a name="l00082"></a><a class="code" href="group__General.html#gga22a20f11c008a0d9b677fc2635922cfeaa62424531516cb168cd1865184eeb7a9">00082</a>         <a class="code" href="group__General.html#gga22a20f11c008a0d9b677fc2635922cfeaa62424531516cb168cd1865184eeb7a9" title="General processing.">OGREPROF_GENERAL</a> = 0x80000000,
<a name="l00084"></a><a class="code" href="group__General.html#gga22a20f11c008a0d9b677fc2635922cfea025771347fabdae9bb5db80f997ced2c">00084</a>         <a class="code" href="group__General.html#gga22a20f11c008a0d9b677fc2635922cfea025771347fabdae9bb5db80f997ced2c" title="Culling.">OGREPROF_CULLING</a> = 0x40000000,
<a name="l00086"></a><a class="code" href="group__General.html#gga22a20f11c008a0d9b677fc2635922cfea1477e35ccd97730b18c1196a2f7fea64">00086</a>         <a class="code" href="group__General.html#gga22a20f11c008a0d9b677fc2635922cfea1477e35ccd97730b18c1196a2f7fea64" title="Rendering.">OGREPROF_RENDERING</a> = 0x20000000
<a name="l00087"></a>00087     };
<a name="l00088"></a>00088 
<a name="l00099"></a><a class="code" href="classOgre_1_1Profile.html">00099</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Profile.html" title="An individual profile that will be processed by the Profiler.">Profile</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ProfilerAlloc</a> {
<a name="l00100"></a>00100 
<a name="l00101"></a>00101         <span class="keyword">public</span>:
<a name="l00102"></a>00102             <a class="code" href="classOgre_1_1Profile.html" title="An individual profile that will be processed by the Profiler.">Profile</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; profileName, <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> groupID = (<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>)<a class="code" href="group__General.html#gga22a20f11c008a0d9b677fc2635922cfea721f30014dd7fbcd0bfb075ab74ab7d3" title="User default profile.">OGREPROF_USER_DEFAULT</a>);
<a name="l00103"></a>00103             ~<a class="code" href="classOgre_1_1Profile.html" title="An individual profile that will be processed by the Profiler.">Profile</a>();
<a name="l00104"></a>00104 
<a name="l00105"></a>00105         <span class="keyword">protected</span>:
<a name="l00106"></a>00106 
<a name="l00108"></a><a class="code" href="classOgre_1_1Profile.html#a24b779884f27e23f87bb0e9f256d6ac1">00108</a>             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Profile.html#a24b779884f27e23f87bb0e9f256d6ac1" title="The name of this profile.">mName</a>;
<a name="l00110"></a><a class="code" href="classOgre_1_1Profile.html#a640fda752765c42a93e99f3f52b6dd7b">00110</a>             <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1Profile.html#a640fda752765c42a93e99f3f52b6dd7b" title="The group ID.">mGroupID</a>;
<a name="l00111"></a>00111             
<a name="l00112"></a>00112 
<a name="l00113"></a>00113     };
<a name="l00114"></a>00114 
<a name="l00126"></a><a class="code" href="classOgre_1_1Profiler.html">00126</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Profiler.html" title="The profiler allows you to measure the performance of your code.">Profiler</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>&lt;Profiler&gt;, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ProfilerAlloc</a> {
<a name="l00127"></a>00127 
<a name="l00128"></a>00128         <span class="keyword">public</span>:
<a name="l00129"></a>00129             <a class="code" href="classOgre_1_1Profiler.html" title="The profiler allows you to measure the performance of your code.">Profiler</a>();
<a name="l00130"></a>00130             ~<a class="code" href="classOgre_1_1Profiler.html" title="The profiler allows you to measure the performance of your code.">Profiler</a>();
<a name="l00131"></a>00131 
<a name="l00133"></a>00133             <span class="keywordtype">void</span> setTimer(<a class="code" href="classOgre_1_1Timer.html" title="Timer class.">Timer</a>* t);
<a name="l00134"></a>00134 
<a name="l00136"></a>00136             <a class="code" href="classOgre_1_1Timer.html" title="Timer class.">Timer</a>* getTimer();
<a name="l00137"></a>00137 
<a name="l00151"></a>00151             <span class="keywordtype">void</span> beginProfile(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; profileName, <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> groupID = (<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>)<a class="code" href="group__General.html#gga22a20f11c008a0d9b677fc2635922cfea721f30014dd7fbcd0bfb075ab74ab7d3" title="User default profile.">OGREPROF_USER_DEFAULT</a>);
<a name="l00152"></a>00152 
<a name="l00167"></a>00167             <span class="keywordtype">void</span> endProfile(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; profileName, <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> groupID = (<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>)OGREPROF_USER_DEFAULT);
<a name="l00168"></a>00168 
<a name="l00174"></a>00174             <span class="keywordtype">void</span> setEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00175"></a>00175 
<a name="l00177"></a>00177             <span class="keywordtype">bool</span> getEnabled() <span class="keyword">const</span>;
<a name="l00178"></a>00178 
<a name="l00183"></a>00183             <span class="keywordtype">void</span> enableProfile(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; profileName);
<a name="l00184"></a>00184 
<a name="l00189"></a>00189             <span class="keywordtype">void</span> disableProfile(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; profileName);
<a name="l00190"></a>00190 
<a name="l00193"></a><a class="code" href="classOgre_1_1Profiler.html#ad19bcccfdf69b21b9953488cb58de764">00193</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Profiler.html#ad19bcccfdf69b21b9953488cb58de764" title="Set the mask which all profiles must pass to be enabled.">setProfileGroupMask</a>(<a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> mask) { mProfileMask = mask; }
<a name="l00196"></a><a class="code" href="classOgre_1_1Profiler.html#a485151cf50e74b67a1fed85a8517d62c">00196</a>             <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1Profiler.html#a485151cf50e74b67a1fed85a8517d62c" title="Get the mask which all profiles must pass to be enabled.">getProfileGroupMask</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mProfileMask; }
<a name="l00197"></a>00197 
<a name="l00203"></a>00203             <span class="keywordtype">bool</span> watchForMax(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; profileName);
<a name="l00204"></a>00204 
<a name="l00210"></a>00210             <span class="keywordtype">bool</span> watchForMin(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; profileName);
<a name="l00211"></a>00211 
<a name="l00221"></a>00221             <span class="keywordtype">bool</span> watchForLimit(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; profileName, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> limit, <span class="keywordtype">bool</span> greaterThan = <span class="keyword">true</span>);
<a name="l00222"></a>00222 
<a name="l00224"></a>00224             <span class="keywordtype">void</span> logResults();
<a name="l00225"></a>00225 
<a name="l00227"></a>00227             <span class="keywordtype">void</span> reset();
<a name="l00228"></a>00228 
<a name="l00229"></a><a class="code" href="classOgre_1_1Profiler.html#a50e3d0c7f42e8ab43af83d13a8acc6cb">00229</a>             <span class="keyword">enum</span> <a class="code" href="classOgre_1_1Profiler.html#a50e3d0c7f42e8ab43af83d13a8acc6cb">DisplayMode</a>
<a name="l00230"></a>00230             {
<a name="l00232"></a><a class="code" href="classOgre_1_1Profiler.html#a50e3d0c7f42e8ab43af83d13a8acc6cba0e3d543da3084b0cb6a403509f8e18d6">00232</a>                 <a class="code" href="classOgre_1_1Profiler.html#a50e3d0c7f42e8ab43af83d13a8acc6cba0e3d543da3084b0cb6a403509f8e18d6" title="Display % frame usage on the overlay.">DISPLAY_PERCENTAGE</a>,
<a name="l00234"></a><a class="code" href="classOgre_1_1Profiler.html#a50e3d0c7f42e8ab43af83d13a8acc6cba2d6fc33d16b14163828af85aa2697d13">00234</a>                 DISPLAY_MILLISECONDS
<a name="l00235"></a>00235             };
<a name="l00236"></a>00236 
<a name="l00239"></a><a class="code" href="classOgre_1_1Profiler.html#afd327712037dfcda0145e257137f0016">00239</a>             <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Profiler.html#afd327712037dfcda0145e257137f0016" title="Set the display mode for the overlay.">setDisplayMode</a>(<a class="code" href="classOgre_1_1Profiler.html#a50e3d0c7f42e8ab43af83d13a8acc6cb">DisplayMode</a> d) { mDisplayMode = d; }
<a name="l00242"></a><a class="code" href="classOgre_1_1Profiler.html#a2b61483f5709182e8ec2f39bf42e4e14">00242</a>             <a class="code" href="classOgre_1_1Profiler.html#a50e3d0c7f42e8ab43af83d13a8acc6cb">DisplayMode</a> <a class="code" href="classOgre_1_1Profiler.html#a2b61483f5709182e8ec2f39bf42e4e14" title="Get the display mode for the overlay.">getDisplayMode</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mDisplayMode; }
<a name="l00243"></a>00243 
<a name="l00245"></a>00245             <span class="keywordtype">void</span> setUpdateDisplayFrequency(<a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> freq);
<a name="l00246"></a>00246 
<a name="l00248"></a>00248             <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> getUpdateDisplayFrequency() <span class="keyword">const</span>;
<a name="l00249"></a>00249 
<a name="l00251"></a>00251             <span class="keywordtype">void</span> setOverlayDimensions(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> width, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> height);
<a name="l00252"></a>00252 
<a name="l00254"></a>00254             <span class="keywordtype">void</span> setOverlayPosition(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> left, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> top);
<a name="l00255"></a>00255 
<a name="l00256"></a>00256             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getOverlayWidth() <span class="keyword">const</span>;
<a name="l00257"></a>00257             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getOverlayHeight() <span class="keyword">const</span>;
<a name="l00258"></a>00258             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getOverlayLeft() <span class="keyword">const</span>;
<a name="l00259"></a>00259             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getOverlayTop() <span class="keyword">const</span>;
<a name="l00260"></a>00260 
<a name="l00276"></a>00276             <span class="keyword">static</span> <a class="code" href="classOgre_1_1Profiler.html" title="The profiler allows you to measure the performance of your code.">Profiler</a>&amp; getSingleton(<span class="keywordtype">void</span>);
<a name="l00292"></a>00292             <span class="keyword">static</span> <a class="code" href="classOgre_1_1Profiler.html" title="The profiler allows you to measure the performance of your code.">Profiler</a>* getSingletonPtr(<span class="keywordtype">void</span>);
<a name="l00293"></a>00293 
<a name="l00294"></a>00294         <span class="keyword">protected</span>:
<a name="l00295"></a>00295 
<a name="l00297"></a>00297             <span class="keywordtype">void</span> initialize();
<a name="l00298"></a>00298 
<a name="l00300"></a>00300             <span class="keywordtype">void</span> displayResults();
<a name="l00301"></a>00301 
<a name="l00303"></a>00303             <span class="keywordtype">void</span> processFrameStats();
<a name="l00304"></a>00304 
<a name="l00306"></a>00306             <span class="keywordtype">void</span> changeEnableState();
<a name="l00307"></a>00307 
<a name="l00309"></a>00309             <a class="code" href="classOgre_1_1OverlayContainer.html" title="A 2D element which contains other OverlayElement instances.">OverlayContainer</a>* createContainer();
<a name="l00310"></a>00310 
<a name="l00312"></a>00312             <a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>* createTextArea(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> width, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> height, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> top, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> left, 
<a name="l00313"></a>00313                                        <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> fontSize, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; caption, <span class="keywordtype">bool</span> show = <span class="keyword">true</span>);
<a name="l00314"></a>00314 
<a name="l00316"></a>00316             <a class="code" href="classOgre_1_1OverlayElement.html" title="Abstract definition of a 2D element to be displayed in an Overlay.">OverlayElement</a>* createPanel(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> width, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> height, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> top, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> left, 
<a name="l00317"></a>00317                                     <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; materialName, <span class="keywordtype">bool</span> show = <span class="keyword">true</span>);
<a name="l00318"></a>00318 
<a name="l00320"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileInstance.html">00320</a>             <span class="keyword">struct </span><a class="code" href="structOgre_1_1Profiler_1_1ProfileInstance.html" title="Represents an individual profile call.">ProfileInstance</a> {
<a name="l00321"></a>00321 
<a name="l00323"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileInstance.html#ab97c7822bee63c0a8779b6d539bbe0fb">00323</a>                 <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>      <a class="code" href="structOgre_1_1Profiler_1_1ProfileInstance.html#ab97c7822bee63c0a8779b6d539bbe0fb" title="The name of the profile.">name</a>;
<a name="l00324"></a>00324 
<a name="l00326"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileInstance.html#a1643d89b6d2e6ae826ed41b473ca971c">00326</a>                 <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>      <a class="code" href="structOgre_1_1Profiler_1_1ProfileInstance.html#a1643d89b6d2e6ae826ed41b473ca971c" title="The name of the parent, empty string if root.">parent</a>;
<a name="l00327"></a>00327 
<a name="l00329"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileInstance.html#a785469fb2684cc7bfd1f58ba9502d422">00329</a>                 <a class="code" href="namespaceOgre.html#a4304981347643708ee9a7ba8884e5758">ulong</a>       <a class="code" href="structOgre_1_1Profiler_1_1ProfileInstance.html#a785469fb2684cc7bfd1f58ba9502d422" title="The time this profile was started.">currTime</a>;
<a name="l00330"></a>00330 
<a name="l00333"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileInstance.html#a641ea8c3f3083597216b11e39d929a1e">00333</a>                 <a class="code" href="namespaceOgre.html#a4304981347643708ee9a7ba8884e5758">ulong</a>       <a class="code" href="structOgre_1_1Profiler_1_1ProfileInstance.html#a641ea8c3f3083597216b11e39d929a1e" title="Represents the total time of all child profiles to subtract from this profile.">accum</a>;
<a name="l00334"></a>00334 
<a name="l00336"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileInstance.html#a30bc0db31ef4e1ff718d89004e3bff4a">00336</a>                 <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a>        <a class="code" href="structOgre_1_1Profiler_1_1ProfileInstance.html#a30bc0db31ef4e1ff718d89004e3bff4a" title="The hierarchical level of this profile, 0 being the root profile.">hierarchicalLvl</a>;
<a name="l00337"></a>00337             };
<a name="l00338"></a>00338 
<a name="l00341"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileFrame.html">00341</a>             <span class="keyword">struct </span><a class="code" href="structOgre_1_1Profiler_1_1ProfileFrame.html" title="Represents the total timing information of a profile since profiles can be called more than once each...">ProfileFrame</a> {
<a name="l00342"></a>00342                 
<a name="l00344"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileFrame.html#af444a2a77f7bb3e2387aec94c539a7fb">00344</a>                 <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>  <a class="code" href="structOgre_1_1Profiler_1_1ProfileFrame.html#af444a2a77f7bb3e2387aec94c539a7fb" title="The name of the profile.">name</a>;
<a name="l00345"></a>00345 
<a name="l00347"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileFrame.html#a89cf3553385a4aaadf99061f920249b1">00347</a>                 <a class="code" href="namespaceOgre.html#a4304981347643708ee9a7ba8884e5758">ulong</a>   <a class="code" href="structOgre_1_1Profiler_1_1ProfileFrame.html#a89cf3553385a4aaadf99061f920249b1" title="The total time this profile has taken this frame.">frameTime</a>;
<a name="l00348"></a>00348 
<a name="l00350"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileFrame.html#a449b6583375ed3ed8c4a9cd872496cd9">00350</a>                 <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a>    <a class="code" href="structOgre_1_1Profiler_1_1ProfileFrame.html#a449b6583375ed3ed8c4a9cd872496cd9" title="The number of times this profile was called this frame.">calls</a>;
<a name="l00351"></a>00351 
<a name="l00353"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileFrame.html#af9530dfafd95f21de7c508bb99fe4f84">00353</a>                 <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a>    <a class="code" href="structOgre_1_1Profiler_1_1ProfileFrame.html#af9530dfafd95f21de7c508bb99fe4f84" title="The hierarchical level of this profile, 0 being the main loop.">hierarchicalLvl</a>;
<a name="l00354"></a>00354 
<a name="l00355"></a>00355             };
<a name="l00356"></a>00356             
<a name="l00358"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html">00358</a>             <span class="keyword">struct </span><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html" title="Represents a history of each profile during the duration of the app.">ProfileHistory</a> {
<a name="l00359"></a>00359 
<a name="l00361"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#acf3e9dcca109ad8ed6e480f1253e0873">00361</a>                 <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>  <a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#acf3e9dcca109ad8ed6e480f1253e0873" title="The name of the profile.">name</a>;
<a name="l00362"></a>00362 
<a name="l00364"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#a1087b90301ee1df46f78cd7988bfcc81">00364</a>                 <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>    <a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#a1087b90301ee1df46f78cd7988bfcc81" title="The current percentage of frame time this profile has taken.">currentTimePercent</a>; 
<a name="l00366"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#affe2faf3111815183448fb52f9daea1f">00366</a>                 <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>    <a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#affe2faf3111815183448fb52f9daea1f" title="The current frame time this profile has taken in milliseconds.">currentTimeMillisecs</a>;
<a name="l00367"></a>00367 
<a name="l00369"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#a601317ff8ae3e25e423521db80fe9fbf">00369</a>                 <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>    <a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#a601317ff8ae3e25e423521db80fe9fbf" title="The maximum percentage of frame time this profile has taken.">maxTimePercent</a>; 
<a name="l00371"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#afcac8a0fb80d99a9583efa15ede25a1e">00371</a>                 <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>    <a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#afcac8a0fb80d99a9583efa15ede25a1e" title="The maximum frame time this profile has taken in milliseconds.">maxTimeMillisecs</a>; 
<a name="l00372"></a>00372 
<a name="l00374"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#acbf4cb3bc0a7699e531c3c1fb6a01a3a">00374</a>                 <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>    <a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#acbf4cb3bc0a7699e531c3c1fb6a01a3a" title="The minimum percentage of frame time this profile has taken.">minTimePercent</a>; 
<a name="l00376"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#affa2efcde4908e4f1c9d9e902cd89575">00376</a>                 <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>    <a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#affa2efcde4908e4f1c9d9e902cd89575" title="The minimum frame time this profile has taken in milliseconds.">minTimeMillisecs</a>; 
<a name="l00377"></a>00377 
<a name="l00379"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#ab918db2b1abc44372b98ee8ca14d86ad">00379</a>                 <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a>    <a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#ab918db2b1abc44372b98ee8ca14d86ad" title="The number of times this profile has been called each frame.">numCallsThisFrame</a>;
<a name="l00380"></a>00380 
<a name="l00382"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#a0bbd3ecdff3b3e80dc07acd0c2f54c4f">00382</a>                 <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>    <a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#a0bbd3ecdff3b3e80dc07acd0c2f54c4f" title="The total percentage of frame time this profile has taken.">totalTimePercent</a>;
<a name="l00384"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#a253036b7297b0c63954888948013facb">00384</a>                 <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>    <a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#a253036b7297b0c63954888948013facb" title="The total frame time this profile has taken in milliseconds.">totalTimeMillisecs</a>;
<a name="l00385"></a>00385 
<a name="l00388"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#ada7dfb141aae4c509b518b4f46fae523">00388</a>                 <a class="code" href="namespaceOgre.html#a4304981347643708ee9a7ba8884e5758">ulong</a>   <a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#ada7dfb141aae4c509b518b4f46fae523" title="The total number of times this profile was called (used to calculate average)">totalCalls</a>; 
<a name="l00389"></a>00389 
<a name="l00391"></a><a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#a9ab93f91e00cfdf99f5ef613e9f008d2">00391</a>                 <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a>    <a class="code" href="structOgre_1_1Profiler_1_1ProfileHistory.html#a9ab93f91e00cfdf99f5ef613e9f008d2" title="The hierarchical level of this profile, 0 being the root profile.">hierarchicalLvl</a>;
<a name="l00392"></a>00392 
<a name="l00393"></a>00393             };
<a name="l00394"></a>00394 
<a name="l00395"></a>00395             
<a name="l00396"></a><a class="code" href="classOgre_1_1Profiler.html#aa2c80f0ab41d4de58e1b57fbeca3e270">00396</a>             <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html">list&lt;ProfileInstance&gt;::type</a> <a class="code" href="classOgre_1_1Profiler.html#aa2c80f0ab41d4de58e1b57fbeca3e270">ProfileStack</a>;
<a name="l00397"></a><a class="code" href="classOgre_1_1Profiler.html#a8298d80c034d7e5014eb825e7ef1d571">00397</a>             <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html">list&lt;ProfileFrame&gt;::type</a> <a class="code" href="classOgre_1_1Profiler.html#a8298d80c034d7e5014eb825e7ef1d571">ProfileFrameList</a>;
<a name="l00398"></a><a class="code" href="classOgre_1_1Profiler.html#a800e5c5d662fc92be9d99a0ce13d0b3e">00398</a>             <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html">list&lt;ProfileHistory&gt;::type</a> <a class="code" href="classOgre_1_1Profiler.html#a800e5c5d662fc92be9d99a0ce13d0b3e">ProfileHistoryList</a>;
<a name="l00399"></a><a class="code" href="classOgre_1_1Profiler.html#a00ddaf4ebef695c8dbdf238a65991b3d">00399</a>             <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, ProfileHistoryList::iterator&gt;::type</a> <a class="code" href="classOgre_1_1Profiler.html#a00ddaf4ebef695c8dbdf238a65991b3d">ProfileHistoryMap</a>;
<a name="l00400"></a><a class="code" href="classOgre_1_1Profiler.html#a6d1cbcba96453723bf2ee774518c5228">00400</a>             <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, bool&gt;::type</a> <a class="code" href="classOgre_1_1Profiler.html#a6d1cbcba96453723bf2ee774518c5228">DisabledProfileMap</a>;
<a name="l00401"></a>00401 
<a name="l00402"></a><a class="code" href="classOgre_1_1Profiler.html#a80b34d6af36b5f9c3dd026781d27ac53">00402</a>             <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html">list&lt;OverlayElement*&gt;::type</a> <a class="code" href="classOgre_1_1Profiler.html#a80b34d6af36b5f9c3dd026781d27ac53">ProfileBarList</a>;
<a name="l00403"></a>00403 
<a name="l00405"></a><a class="code" href="classOgre_1_1Profiler.html#a7342bed28d571f2657b1a3f04ebd59e0">00405</a>             <a class="code" href="classOgre_1_1Profiler.html#aa2c80f0ab41d4de58e1b57fbeca3e270">ProfileStack</a> <a class="code" href="classOgre_1_1Profiler.html#a7342bed28d571f2657b1a3f04ebd59e0" title="A stack for each individual profile per frame.">mProfiles</a>;
<a name="l00406"></a>00406 
<a name="l00409"></a><a class="code" href="classOgre_1_1Profiler.html#ab6e938d9f36e20068d7f96073112fb77">00409</a>             <a class="code" href="classOgre_1_1Profiler.html#a8298d80c034d7e5014eb825e7ef1d571">ProfileFrameList</a> <a class="code" href="classOgre_1_1Profiler.html#ab6e938d9f36e20068d7f96073112fb77" title="Accumulates the results of each profile per frame (since a profile can be called more than once a fra...">mProfileFrame</a>;
<a name="l00410"></a>00410 
<a name="l00412"></a><a class="code" href="classOgre_1_1Profiler.html#a28700bb39bbc70ec4ecac22050d13f2c">00412</a>             <a class="code" href="classOgre_1_1Profiler.html#a800e5c5d662fc92be9d99a0ce13d0b3e">ProfileHistoryList</a> <a class="code" href="classOgre_1_1Profiler.html#a28700bb39bbc70ec4ecac22050d13f2c" title="Keeps track of the statistics of each profile.">mProfileHistory</a>;
<a name="l00413"></a>00413 
<a name="l00415"></a><a class="code" href="classOgre_1_1Profiler.html#aba7e5d0b1b2f41e1c63563d9d49eddba">00415</a>             <a class="code" href="classOgre_1_1Profiler.html#a00ddaf4ebef695c8dbdf238a65991b3d">ProfileHistoryMap</a> <a class="code" href="classOgre_1_1Profiler.html#aba7e5d0b1b2f41e1c63563d9d49eddba" title="We use this for quick look-ups of profiles in the history list.">mProfileHistoryMap</a>;
<a name="l00416"></a>00416 
<a name="l00418"></a><a class="code" href="classOgre_1_1Profiler.html#a3d8be007a0ed8266c06bd27968b7974e">00418</a>             <a class="code" href="classOgre_1_1Profiler.html#a6d1cbcba96453723bf2ee774518c5228">DisabledProfileMap</a> <a class="code" href="classOgre_1_1Profiler.html#a3d8be007a0ed8266c06bd27968b7974e" title="Holds the names of disabled profiles.">mDisabledProfiles</a>;
<a name="l00419"></a>00419 
<a name="l00421"></a><a class="code" href="classOgre_1_1Profiler.html#ab3865827e7b3ac4ad3b9b3e1fdda9d77">00421</a>             <a class="code" href="classOgre_1_1Profiler.html#a80b34d6af36b5f9c3dd026781d27ac53">ProfileBarList</a> <a class="code" href="classOgre_1_1Profiler.html#ab3865827e7b3ac4ad3b9b3e1fdda9d77" title="Holds the display bars for each profile results.">mProfileBars</a>;
<a name="l00422"></a>00422 
<a name="l00424"></a><a class="code" href="classOgre_1_1Profiler.html#a8426a136e3fd6574b4b3afeca58fd5d9">00424</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Profiler.html#a8426a136e3fd6574b4b3afeca58fd5d9" title="Whether the GUI elements have been initialized.">mInitialized</a>;
<a name="l00425"></a>00425 
<a name="l00427"></a><a class="code" href="classOgre_1_1Profiler.html#a54a0a835e1a8454e52360b18f6375aa3">00427</a>             <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> <a class="code" href="classOgre_1_1Profiler.html#a54a0a835e1a8454e52360b18f6375aa3" title="The max number of profiles we can display.">mMaxDisplayProfiles</a>;
<a name="l00428"></a>00428 
<a name="l00430"></a><a class="code" href="classOgre_1_1Profiler.html#af0b84f8988fb21a9b1edb737687e1d55">00430</a>             <a class="code" href="classOgre_1_1Overlay.html" title="Represents a layer which is rendered on top of the &#39;normal&#39; scene contents.">Overlay</a>* <a class="code" href="classOgre_1_1Profiler.html#af0b84f8988fb21a9b1edb737687e1d55" title="The overlay which contains our profiler results display.">mOverlay</a>;
<a name="l00431"></a>00431 
<a name="l00433"></a><a class="code" href="classOgre_1_1Profiler.html#a787571c7aff51fec80a5602a2e868a78">00433</a>             <a class="code" href="classOgre_1_1OverlayContainer.html" title="A 2D element which contains other OverlayElement instances.">OverlayContainer</a>* <a class="code" href="classOgre_1_1Profiler.html#a787571c7aff51fec80a5602a2e868a78" title="The window that displays the profiler results.">mProfileGui</a>;
<a name="l00434"></a>00434 
<a name="l00436"></a><a class="code" href="classOgre_1_1Profiler.html#a093f84942dc4ceb8e959588dbcd2cde0">00436</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Profiler.html#a093f84942dc4ceb8e959588dbcd2cde0" title="The height of each bar.">mBarHeight</a>;
<a name="l00437"></a>00437 
<a name="l00439"></a><a class="code" href="classOgre_1_1Profiler.html#a01964e2873acf707b46ce955d4eaa481">00439</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Profiler.html#a01964e2873acf707b46ce955d4eaa481" title="The height of the stats window.">mGuiHeight</a>;
<a name="l00440"></a>00440 
<a name="l00442"></a><a class="code" href="classOgre_1_1Profiler.html#a7aa7a6e1aefb5d3fda203ab2bbf2345b">00442</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Profiler.html#a7aa7a6e1aefb5d3fda203ab2bbf2345b" title="The width of the stats window.">mGuiWidth</a>;
<a name="l00443"></a>00443 
<a name="l00445"></a><a class="code" href="classOgre_1_1Profiler.html#a3cc083369ba6d2cbccf9e3805a5a2c04">00445</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Profiler.html#a3cc083369ba6d2cbccf9e3805a5a2c04" title="The horz position of the stats window.">mGuiLeft</a>;
<a name="l00446"></a>00446 
<a name="l00448"></a><a class="code" href="classOgre_1_1Profiler.html#a82fdce63913682f9c35dadb6ceaea91a">00448</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Profiler.html#a82fdce63913682f9c35dadb6ceaea91a" title="The vertical position of the stats window.">mGuiTop</a>;
<a name="l00449"></a>00449 
<a name="l00451"></a><a class="code" href="classOgre_1_1Profiler.html#ad777b9d07a5f12464f1fa7c6ed7a21c1">00451</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Profiler.html#ad777b9d07a5f12464f1fa7c6ed7a21c1" title="The size of the indent for each profile display bar.">mBarIndent</a>;
<a name="l00452"></a>00452 
<a name="l00454"></a><a class="code" href="classOgre_1_1Profiler.html#a9394507398be0a65c25bc90863eaf6c4">00454</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Profiler.html#a9394507398be0a65c25bc90863eaf6c4" title="The width of the border between the profile window and each bar.">mGuiBorderWidth</a>;
<a name="l00455"></a>00455 
<a name="l00457"></a><a class="code" href="classOgre_1_1Profiler.html#ac914f52e30c8f425a50b1da30c3105a1">00457</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Profiler.html#ac914f52e30c8f425a50b1da30c3105a1" title="The width of the min, avg, and max lines in a profile display.">mBarLineWidth</a>;
<a name="l00458"></a>00458 
<a name="l00460"></a><a class="code" href="classOgre_1_1Profiler.html#a21239e45f15d4f19957f88dc6631ce95">00460</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Profiler.html#a21239e45f15d4f19957f88dc6631ce95" title="The distance between bars.">mBarSpacing</a>;
<a name="l00461"></a>00461 
<a name="l00464"></a><a class="code" href="classOgre_1_1Profiler.html#a634f43e704803cbc4c4974d5363d3441">00464</a>             <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> <a class="code" href="classOgre_1_1Profiler.html#a634f43e704803cbc4c4974d5363d3441" title="The number of frames that must elapse before the current frame display is updated.">mUpdateDisplayFrequency</a>;
<a name="l00465"></a>00465 
<a name="l00467"></a><a class="code" href="classOgre_1_1Profiler.html#a342bdc46fd887e5c5a45806dfdd6be0b">00467</a>             <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> <a class="code" href="classOgre_1_1Profiler.html#a342bdc46fd887e5c5a45806dfdd6be0b" title="The number of elapsed frame, used with mUpdateDisplayFrequency.">mCurrentFrame</a>;
<a name="l00468"></a>00468 
<a name="l00470"></a><a class="code" href="classOgre_1_1Profiler.html#a38b67a7679f11d7ececbeedc4f354a1f">00470</a>             <a class="code" href="classOgre_1_1Timer.html" title="Timer class.">Timer</a>* <a class="code" href="classOgre_1_1Profiler.html#a38b67a7679f11d7ececbeedc4f354a1f" title="The timer used for profiling.">mTimer</a>;
<a name="l00471"></a>00471 
<a name="l00473"></a><a class="code" href="classOgre_1_1Profiler.html#a044204c438fc5eec7806b586129cf70e">00473</a>             <a class="code" href="namespaceOgre.html#a4304981347643708ee9a7ba8884e5758">ulong</a> <a class="code" href="classOgre_1_1Profiler.html#a044204c438fc5eec7806b586129cf70e" title="The total time each frame takes.">mTotalFrameTime</a>;
<a name="l00474"></a>00474 
<a name="l00476"></a><a class="code" href="classOgre_1_1Profiler.html#a087887f554607555dbfc34111583bd41">00476</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Profiler.html#a087887f554607555dbfc34111583bd41" title="Whether this profiler is enabled.">mEnabled</a>;
<a name="l00477"></a>00477 
<a name="l00480"></a><a class="code" href="classOgre_1_1Profiler.html#adca0878a49bfc3a42f5a3329685b60d2">00480</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Profiler.html#adca0878a49bfc3a42f5a3329685b60d2" title="Keeps track of whether this profiler has received a request to be enabled/disabled.">mEnableStateChangePending</a>;
<a name="l00481"></a>00481 
<a name="l00484"></a><a class="code" href="classOgre_1_1Profiler.html#a1803e714976005d298d2742fec3e1a09">00484</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Profiler.html#a1803e714976005d298d2742fec3e1a09" title="Keeps track of the new enabled/disabled state that the user has requested which will be applied after...">mNewEnableState</a>;
<a name="l00485"></a>00485 
<a name="l00487"></a><a class="code" href="classOgre_1_1Profiler.html#a6df42d4b04253c3d7fa7a4082dc91bcf">00487</a>             <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="classOgre_1_1Profiler.html#a6df42d4b04253c3d7fa7a4082dc91bcf" title="Mask to decide whether a type of profile is enabled or not.">mProfileMask</a>;
<a name="l00488"></a>00488 
<a name="l00490"></a><a class="code" href="classOgre_1_1Profiler.html#a042b5638e084d62470ecd62b407ad3e9">00490</a>             <a class="code" href="classOgre_1_1Profiler.html#a50e3d0c7f42e8ab43af83d13a8acc6cb">DisplayMode</a> <a class="code" href="classOgre_1_1Profiler.html#a042b5638e084d62470ecd62b407ad3e9" title="How to display the overlay.">mDisplayMode</a>;
<a name="l00491"></a>00491 
<a name="l00493"></a><a class="code" href="classOgre_1_1Profiler.html#aa75e34e44dbc5afedf28615467bf2f42">00493</a>             <a class="code" href="namespaceOgre.html#a4304981347643708ee9a7ba8884e5758">ulong</a> <a class="code" href="classOgre_1_1Profiler.html#aa75e34e44dbc5afedf28615467bf2f42" title="The max frame time recorded.">mMaxTotalFrameTime</a>;
<a name="l00494"></a>00494 
<a name="l00496"></a><a class="code" href="classOgre_1_1Profiler.html#a424f69eded16aed6d1fcb3363c3bc572">00496</a>             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Profiler.html#a424f69eded16aed6d1fcb3363c3bc572" title="Rolling average of millisecs.">mAverageFrameTime</a>;
<a name="l00497"></a><a class="code" href="classOgre_1_1Profiler.html#a07f40435476edf0e9437a94613173075">00497</a>             <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Profiler.html#a07f40435476edf0e9437a94613173075">mResetExtents</a>;
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 
<a name="l00500"></a>00500     }; <span class="comment">// end class</span>
<a name="l00504"></a>00504 <span class="comment"></span>} <span class="comment">// end namespace</span>
<a name="l00505"></a>00505 
<a name="l00506"></a>00506 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
